from GeometricObjects import *
from Vectorial import *
from TransMatrices import *
import math
import Global
# Ignorare questa funzione
"""
def __center(ps):
	aus = Point(0.0, 0.0, 0.0)
	for i in range(0, len(ps)):
		aus = aus + ps[0]
	return aus / len(ps)
"""
# Ignorare questa funzione per il momento
"""
def __first_profile(pf, v, p):
	profileNormal = (pf[1] - pf[0]).getVector()**(pf[2] - pf[1]).getVector() #Attenzione controllare
	m = get_rotation_matrix(profileNormal**v, acos((profileNormal*v)/(abs(profileNormal)*abs(v))) )
	pf = pf * m
	m = get_translation_matrix( (p - __center(pf)).getVector() ) #Controllare il generatore di matrice
	pf = pf * m
	return pf
"""



def scaleFunction(t):
	if t > 1:
		return 1
	else:
		return t

def rotationFunction(t):
	return math.pi*t


#Funzioni identita'

"""
def scaleFunction(t):
	return 1.0

def rotationFunction(t):
	return 0.0
"""






def __getPoints(ps):
	#Trasforma una lista di liste in un oggetto di tipo Points
	result = Points(len(ps))
	for i in range(0, len(ps)):
		result[i].setX(ps[i][0])
		result[i].setY(ps[i][1])
		reuslt[i].setZ(ps[i][2])
	return result

#######
"""
Warning
1 - Per il momemto manca l'ultimo profilo.
2 - In base a come il profilo e' rivolto rispetto al percorso, cambia il risultato. Quello che conta, e' l'inclinazione
    che il profilo ha relativamente al percorso, non lo sfasamento.
"""
#######

def __bit_loft(ps, p1, p2, p3):
	v1 = (p1 - p2).getVector().normalize() + (p3-p2).getVector().normalize()
	# v1 e' il vettore della bisettrice dell'angolo p1 p2 p3
	if abs(v1) <= Global.zero: #se abs(v1) = 0, allora  p1 p2 e p3 sono collineari...
		# ...esistono quindi infinite bisettrici dell'angolo p1 p2 p3. Ne prendo una qualsiasi
		# attraverso il metodo get_orthogonal il quale produce un qualche vettore ortogonale alla direzione p1 p2
		v1 = get_orthogonal( (p1 - p2).getVector() ) #Ottimizzare
	v2 = (p1 - p2).getVector() ** v1 #Ottimizzare
	# v2 e' un vettore ortogonale sia al segmento p2 p1 che al segmento p2 p3

	# Ora calcolo i tre punti del piano sul quale eseguire la proiezione del profilo
	# Il primo punto e' semplicemente p2
	pa = p2.clone()
	# Il secondo punto giace sulla bisettrice dell'angolo p1 p2 p3
	pb = Point(pa.getX() + v1[0], pa.getY() + v1[1], pa.getZ() + v1[2])
	# Il terzo punto e' posizionato su una linea passante per p2 e perpendicolare al piano
	# contenente i punti p1 p2 p3
	pc = Point(pa.getX() + v2[0], pa.getY() + v2[1], pa.getZ() + v2[2])

	# Posso ora calcolare la famosa matrice di proiezione
	m = get_projection_matrix(pa, pb, pc, (p2-p1).getVector())
	# Questa matrice, una volta applicata a dei punti, li proietta sul piano che contiene i
	# punti pa pb e pc
	return ps*m # Applico la matrice m ai punti ps

#L'ultimo profilo, (in un percorso aperto), deve essere proiettato su un piano avente normale pn pn-1, dove
#pn e pn-1 sono rispettivamente l'ultimo e il penultimo punto di path
def __lastProfile(profilo, vettorePiano, puntoPiano):
	z = vettorePiano
	y = get_orthogonal(z)
	x = y**z #Prodotto vettoriale

	pa = puntoPiano
	pb = puntoPiano + x
	pc = puntoPiano + y

	m = get_projection_matrix(pa, pb, pc, z)

	return profilo*m


"""Prima versione:
	profile e' un oggetto di tipo Points. Path, puo' essere un oggetto di tipo Points, oppure una lista
	di oggetti di tipo Point. I due oggetti devono essere in coordinate globali.


	profile deve contenere almeno 3 punti
	path almeno 2
"""

#Chiamare una di queste due funzioni.
def loft(profile, path, f1=scaleFunction, f2=rotationFunction):
	"""profile, viene "proiettato" lungo path. Le varie proiezioni, vengono poi scalate attraverso la funzione
 	   f1, e ruotate, attraverso la funzione f2. Le proiezioni ruotate e scalate, vengono restituite in una lista"""
	path_length = 0.0
	result = []

	# Creazione del primo profilo
	rotationAxe = (path[1] - path[0]).getVector()
	m1 = get_scale_matrix(f1(0.0), f1(0.0), f1(0.0), path[0])
	m2 = get_rotation_matrix(path[0], rotationAxe, f2(0.0))
	aus = profile.clone()
	# Fine creazione primo profilo

	# Inizio Creazione profili intermedi
	if len(path) > 2:
		for i in range(0, len(path) - 2):
			result.append(aus*(m1*m2)) #Le parentesi sono importanti
			aus = __bit_loft(aus, path[i], path[i+1], path[i+2])
			path_length += abs((path[i] - path[i+1]).getVector())
			# Probabilmente questo asse non va bene (in generale) trovarne uno piu' consono
			#rotationAxe = (path[i+1] - path[i]).getVector() #Controllare che questo asse vada bene

			v1 = (path[i] - path[i+1]).getVector().normalize()
			v2 = (path[i+2] - path[i+1]).getVector().normalize()
			rotationAxe = v2 - v1

			m1 = get_scale_matrix(f1(path_length), f1(path_length), f1(path_length), path[i+1])
			m2 = get_rotation_matrix(path[i+1], rotationAxe, f2(path_length))
		# Inserimento del penultimo profilo calcolato
		result.append(aus*(m1*m2)) #Le parentesi sono importanti
	# Fine creazione profili intermedi

	# Ultimo profilo
	rotationAxe = (path[len(path)-1] - path[len(path)-2]).getVector()
	path_length += abs( (path[len(path)-1] - path[len(path)-2]).getVector() )
	m1 = get_scale_matrix(f1(path_length), f1(path_length), f1(path_length), path[len(path)-1])
	m2 = get_rotation_matrix(path[len(path)-1], rotationAxe, f2(path_length))
	aus = __lastProfile(aus, (path[len(path)-2] - path[len(path) -1]).getVector(), path[len(path)-1])
	result.append(aus*(m1*m2))
	# Fine ultimo profilo

	return result


"""Seconda versione
	profile e path sono liste di liste [[x, y, z],[x, y, z], ..., [x, y, z]]

"""
def loft2(profile, path):
	pf = __getPoints(profile)   #Trasformo la lista di liste in un oggetto Points
	path = __getPoints(path)    #Trasformo la lista di liste in un oggetto Points
	return loft(profile, path)
# Anche se profile e path (quando restituiti dalla funzione) sono degli oggetti di tipo Points,
# non e' necessario convertirli in liste di liste in quanto dispongono di operazioni che
# permettono loro di avere un comportamento identico a quello delle liste di liste (in piu' hanno altre
# operazioni, che pero' possono essere ignorate).








