# Per il momento esegue un doppio offset
# Il punto p, serve per stabilire quale dei due segmenti sfalsati conservare. E' necessario aggiungere un
# test che elimini uno dei due segmenti. Siccome potrebbe tornare utile avere entrambi i segmenti si
# potrebbe eseguire tale test fuori da questa funzione.
def offset(p1, p2, p, n, d):
	"""Esegue l'offset di un segmento definito da p1 e p2"""
	# Il vettore n, indica il piano sul quale giace il segmento p1-p2 e pertanto anche il segmento
	# ottenuto dall'operazione di offset. Eseguendo il prodotto vettoriale tra il vettore del
	# segmento p1-p2 e il vettore n, ottengo un vettore ortogonale al segmento p1-p2. v è la
	# normalizzazione di tale vettore.
	v = ((p2 - p1).getVector()**n).normalize()
	# Se moltiplico v per d, e quindi lo sommo (o lo sottraggo) ai punti p1 e p2,
	# ottengo una nuova coppia di punti che definisce un segmento parallelo a p1-p2 e sfalsato da esso
	# di d unita'.
	return [(p1 + d*v, p2 + d*v), (p1 - d*v, p2 - d*v)]











