#Per ora tutte le primitive hanno il metodo draw
#ma non c'e' ancora la flessibilita' di cui abbiamo bisogno.
#Infatti bisogna fare il modo che se si richiama il draw()
#su un oggetto gia' istanziato, questo ridisegni se stesso
#allora si che avremo la possibilita' di editare gli
#attributi.


import Blender
from Blender import NMesh
from Blender import Window
from Blender.Draw import *
from Blender.Window import *
import math
from math import *

class Line3D:

	#Ho dovuto per forza eliminare args perche' mi dava
	#troppi problemi per l'interattivita' con la GUI. E'
	#molto piu' comodo passare una lista con un numero
	#comunque grande di elementi. Vedremo in futuro se
	#riaggiungere args. Ho fatto altri cambiamenti
	#tipo includere il reset di points dentro all'init
	#e semplificare alcuni cicli.--Manuel

	""" Generic Line generator by Jody Pereira
	Version 0.0.2
	"""
	

	def __init__(self, argoments):
		self.pts = []
		if len(argoments) != 1:
			self.pts = argoments
		else:
			self.pts.append(Window.GetCursorPos())
			self.pts.append(argoments[0])
	
	def draw(self):
		poly = NMesh.GetRaw()
		for point in self.pts:
			print "putni della linea",point[0],point[1],point[2]
			v = NMesh.Vert(point[0],point[1],point[2])
			poly.verts.append(v)
		for i in range(len(poly.verts)-1):
			f = NMesh.Face()
			f.v.append(poly.verts[i])
			f.v.append(poly.verts[i+1])
 	  		poly.faces.append(f)
		polyObj = NMesh.PutRaw(poly)
		RedrawAll()

		


class Circle3D:

	"""
	"""
	#def __init__(self, center=Window.GetCursorPos(), radius= 1, vert=32):
	#Ho dovuto modificare l'init, altrimenti la posizione veniva presa solo
	#al momento dell'istanza. Ora lo fa il parser--Manuel--

	def __init__(self, center, radius= 1, vert=32):
		self.center = center
		self.radius = radius
		self.vert = vert
		self.objName = ""
		self.objType = "circle"
		
	def draw(self):

		poly = NMesh.GetRaw()

		for i in range(0, self.vert):
			phi = 3.141592653589 * 2 * i / self.vert
			x = self.radius * cos(phi)
			y = self.radius * sin(phi)
			z = 0
			
			v = NMesh.Vert(x,y,z)
			poly.verts.append(v)

		for i in range (0, len(poly.verts)-1):
			f = NMesh.Face()
			f.v.append(poly.verts[i])
			f.v.append(poly.verts[i+1])
			poly.faces.append(f)

		g = NMesh.Face()
		g.v.append(poly.verts[0])
		g.v.append(poly.verts[i+1])
		poly.faces.append(g)

		polyObj = NMesh.PutRaw(poly)
		self.objName = polyObj.getName()
		polyObj.setLocation(self.center)
		RedrawAll()

class Polyline:

	#Ho modificato la classe in modo che faccia partire
	#la polilinea da qualsiasi oggetto, e nel caso in cui
	#nulla sia selezionato, ne inizi una nuova. In questo
	#modo un solo pulsante fa tutto.--Manuel

	def __init__(self):
		self.objName = ""
		self.objType = "polyline"
				
	def draw(self):
		self.cursorposition = Window.GetCursorPos()
		if len(Blender.Object.GetSelected()) != 0:
			objToAddLine = Blender.Object.GetSelected()[0]
			loc = objToAddLine.getLocation()
			
			if objToAddLine.getType() == "Mesh":
				meshToModify = objToAddLine.getData()
				v = NMesh.Vert(self.cursorposition[0]-loc[0],\
						self.cursorposition[1]-loc[1],\
						self.cursorposition[2]-loc[2])
				meshToModify.verts.append(v)

				for i in range (0, len(meshToModify.verts)-1):
					f = NMesh.Face()
					f.v.append(meshToModify.verts[i])
					f.v.append(meshToModify.verts[i+1])		
   					meshToModify.faces.append(f)
				meshToModify.update()

		else:
			self.poly = NMesh.GetRaw()
			v = NMesh.Vert(self.cursorposition[0],\
						self.cursorposition[1],\
						self.cursorposition[2])

			self.poly.verts.append(v)

			polyObj = NMesh.PutRaw(self.poly)
			Redraw()