"""
	###########################
	Modulo scritto da
		Gianmario Salvetti
	###########################

Questo modulo contiene metodi che permettono di ottenere dei vettori particolari.

"""


from Vectorial import *
import Global

def get_zero_vector():
	return Vector(3)

def get_X_vector():
	"""Produce il vettore dell'asse X"""
	result = Vector(3)
	result[0] = 1.0
	return result

def get_inv_X_vector():
	"""Produce il vettore opposto alla direzione dell'asse X"""
	result = Vector(3)
	result[0] = -1.0
	return result

def get_Y_vector():
	"""Produce il vettore dell'asse Y"""
	result = Vector( 3)
	result[1] = 1.0
	return result

def get_inv_Y_vector():
	"""Produce il vettore opposto alla direzione dell'asse Y"""
	result = Vector(3)
	result[1] = -1.0
	return result

def get_Z_vector():
	"""Produce il vettore dell'asse Z"""
	result = Vector(3)
	result[2] = 1.0
	return result

def get_inv_Z_vector():
	"""Produce il vettore opposto alla direzione dell'asse Z"""
	result = Vector(3)
	result[2] = -1.0
	return result

def get_orthogonal(v):
	"""Calcola un vettore ortogonale a v (poiche' un vettore nello spazio ha infiniti vettori ortogonali)"""
	if len(v) != 3:
		raise ErrorDimVector
	else:
		if abs(v[0]) <= Global.zero:
			return get_X_vector()
		elif abs(v[1]) <= Global.zero:
			return get_Y_vector()
		elif abs(v[2]) <= Global.zero:
			return get_Z_vector()
		else:
			result = get_Z_vector()
			result[1] = 1.0
			result[2] = -(v[1]/v[2])
			return result
